(define-module (ui netinst ajax)
    :use-module (alterator woo)
    :use-module (alterator ajax)
    :use-module (alterator effect)
    :export (init))

(define (ui-list)
  (form-update-enum "image" (woo-list "/netinst" 'language (form-value "language"))))

(define (ui-list-labels)
  (form-update-enum "labels" (woo-list "/netinst/labels" 'language (form-value "language"))))

(define (ui-read)
  (catch/message
    (lambda()
      (form-update-value-list
	'("name" "url" "image" "vnc" "headless" "direction" "vncpassword" "vncconnect" "labels")
	(woo-read-first "/netinst")))))

(define (ui-select)
  (catch/message
    (lambda()
      (woo-write "/netinst"
		 'sel #t
		 'image (form-value "image")
		 'language (form-value "language"))
      (ui-list-labels)
      (ui-read)
      (update-effect))))

(define (ui-delete)
  (catch/message
    (lambda()
      (if (form-confirm (_ "Are you really want to remove image?") (_ "Question") (_ "Yes") (_ "No"))
	(begin
	  (woo-write "/netinst"
		     'del #t
		     'image (form-value "image")
		     'language (form-value "language"))
	  (ui-list)
	  (ui-read)
	  (update-effect))))))

(define (ui-add)
  (catch/message
    (lambda()
      (woo-write "/netinst"
		 'add #t
		 'get_from (form-value "get_from")
		 'add_url (form-value "add_url")
		 'language (form-value "language"))
      (form-replace "/netinst/wait"))))

(define (ui-apply)
  (catch/message
        (lambda()
	  (woo-write "/netinst"
		     'labels (form-value "labels")
		     'vnc (form-value "vnc")
		     'headless (form-value "headless")
		     'direction (form-value "direction")
		     'vncpassword (form-value "vncpassword")
		     'vncconnect (form-value "vncconnect"))
	  )))

(define (init)
  (ui-list)
  (ui-list-labels)
  (ui-read)

  (effect-disable "del_button" "image" "0")
  (effect-hide "url_box" "name" "")
  (effect-enable "add_url" "get_from" "url")

  (effect-disable "direction" "vnc" #f)
  (effect-disable "headless" "vnc" #f)
  (effect-disable "vncconnect" "vnc" #f)
  (effect-disable "vncpassword" "vnc" #f)
  (effect-disable "vncconnect" "direction" "listen")
  (effect-disable "vncpassword" "direction" "connect")

  (init-effect)
  (form-bind "sel_button" "click" ui-select)
  (form-bind "del_button" "click" ui-delete)
  (form-bind "add_button" "click" ui-add)
  (form-bind "apply_button" "click" ui-apply))
