(define-module (ui netinst wait ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :export (init))

(define (update-progress)
  (catch/message
    (lambda()
      (let* ((data (woo-read-first "/netinst/wait" 'language (form-value "language")))
	     (status (woo-get-option data 'status)))

	(cond
	  ((string=? status "progress")
	   (form-update-value-list '("percent" "url") data)
	   (form-update-value "status" (_ "Downloading image..."))
	   (form-set-timeout update-progress 2))
	  ((member status '("done" "stopped"))
	   (form-replace "/netinst"))
	  (else
	    (form-update-value-list '("error") data)
	    (form-update-visibility '("cancel" "p") #f)
	    (form-update-visibility "ok" #t)
	    (form-update-value "status" (_ "Download failed"))))))))

(define (cancel-progress)
  (catch/message
    (lambda()
      (woo-write "/netinst/wait" 'cancel #t 'language (form-value "language")))))

(define (ok-progress)
  (form-replace "/netinst"))

(define (init)
  (update-progress)
  (form-bind "cancel" "click" cancel-progress)
  (form-bind "ok" "click" ok-progress))
